Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jetty.server
Class Dispatcher

    java.lang.Object
      org.eclipse.jetty.server.Dispatcher

All Implemented Interfaces:
  RequestDispatcher

    public class Dispatcher

extends java.lang.Object
implements RequestDispatcher

Servlet RequestDispatcher.

Field Summary
`static java.lang.String` | `__FORWARD_PREFIX` Dispatch include attribute names
`static java.lang.String` | `__INCLUDE_PREFIX` Dispatch include attribute names
`static java.lang.String` | `__JSP_FILE` JSP attributes

Fields inherited from interface javax.servlet.RequestDispatcher
`ERROR_EXCEPTION, ERROR_EXCEPTION_TYPE, ERROR_MESSAGE, ERROR_REQUEST_URI, ERROR_SERVLET_NAME, ERROR_STATUS_CODE, FORWARD_CONTEXT_PATH, FORWARD_PATH_INFO, FORWARD_QUERY_STRING, FORWARD_REQUEST_URI, FORWARD_SERVLET_PATH, INCLUDE_CONTEXT_PATH, INCLUDE_PATH_INFO, INCLUDE_QUERY_STRING, INCLUDE_REQUEST_URI, INCLUDE_SERVLET_PATH`

Constructor Summary
`Dispatcher(ContextHandler contextHandler, java.lang.String name)` Constructor.
`Dispatcher(ContextHandler contextHandler, java.lang.String uri, java.lang.String pathInContext, java.lang.String query)`

Method Summary
`void` | `error(ServletRequest request, ServletResponse response)`
`void` | `forward(ServletRequest request, ServletResponse response)` Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server.
`protected void` | `forward(ServletRequest request, ServletResponse response, DispatcherType dispatch)`
`void` | `include(ServletRequest request, ServletResponse response)` Includes the content of a resource (servlet, JSP page, HTML file) in the response.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### __INCLUDE_PREFIX

    public static final java.lang.String __INCLUDE_PREFIX

  Dispatch include attribute names

  See Also:
    Constant Field Values

### __FORWARD_PREFIX

    public static final java.lang.String __FORWARD_PREFIX

  Dispatch include attribute names

  See Also:
    Constant Field Values

### __JSP_FILE

    public static final java.lang.String __JSP_FILE

  JSP attributes

  See Also:
    Constant Field Values

Constructor Detail

### Dispatcher

    public Dispatcher(ContextHandler contextHandler,
                      java.lang.String uri,
                      java.lang.String pathInContext,
                      java.lang.String query)

Parameters:
  `contextHandler` -
  `uri` -
  `pathInContext` -
  `query` -

### Dispatcher

    public Dispatcher(ContextHandler contextHandler,
                      java.lang.String name)
               throws java.lang.IllegalStateException

  Constructor.

  Parameters:
    `contextHandler` -
    `name` -
  Throws:
    `java.lang.IllegalStateException`

Method Detail

### forward

    public void forward(ServletRequest request,
                        ServletResponse response)
                 throws ServletException,
                        java.io.IOException

  Description copied from interface: `RequestDispatcher`
  Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server. This method allows one servlet to do preliminary processing of a request and another resource to generate the response.

  For a `RequestDispatcher` obtained via `getRequestDispatcher()`, the `ServletRequest` object has its path elements and parameters adjusted to match the path of the target resource.

  `forward` should be called before the response has been committed to the client (before response body output has been flushed). If the response already has been committed, this method throws an `IllegalStateException`. Uncommitted output in the response buffer is automatically cleared before the forward.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  This method sets the dispatcher type of the given request to `DispatcherType.FORWARD`.

  Specified by:
    `forward` in interface `RequestDispatcher`
  Parameters:
    `request` - a `ServletRequest` object that represents the request the client makes of the servlet
    `response` - a `ServletResponse` object that represents the response the servlet returns to the client
  Throws:
    `ServletException` - if the target resource throws this exception
    `java.io.IOException` - if the target resource throws this exception
  See Also:
    `ServletRequest.getDispatcherType()`

### error

    public void error(ServletRequest request,
                      ServletResponse response)
               throws ServletException,
                      java.io.IOException

  Throws:
    `ServletException`
    `java.io.IOException`

### include

    public void include(ServletRequest request,
                        ServletResponse response)
                 throws ServletException,
                        java.io.IOException

  Description copied from interface: `RequestDispatcher`
  Includes the content of a resource (servlet, JSP page, HTML file) in the response. In essence, this method enables programmatic server-side includes.

  The `ServletResponse` object has its path elements and parameters remain unchanged from the caller's. The included servlet cannot change the response status code or set headers; any attempt to make a change is ignored.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  This method sets the dispatcher type of the given request to `DispatcherType.INCLUDE`.

  Specified by:
    `include` in interface `RequestDispatcher`
  Parameters:
    `request` - a `ServletRequest` object that contains the client's request
    `response` - a `ServletResponse` object that contains the servlet's response
  Throws:
    `ServletException` - if the included resource throws this exception
    `java.io.IOException` - if the included resource throws this exception
  See Also:
    `ServletRequest.getDispatcherType()`

### forward

    protected void forward(ServletRequest request,
                           ServletResponse response,
                           DispatcherType dispatch)
                    throws ServletException,
                           java.io.IOException

  Throws:
    `ServletException`
    `java.io.IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.